cr              EQU             0Dh                     ;carriage return
lf              EQU             0Ah                     ;line feed

code            SEGMENT                              
                ASSUME          CS:code,DS:code
                ORG             100h                    ;beginning of program

verybegin:      JMP             tsrsetup
int21orig1      DW ?
int21orig2      DW ?
tsr:
                PUSHF
                PUSH            AX
                PUSH            BX
                PUSH            BP
                PUSH            DS
                CMP             AX,3D40h                ;tbscan and tbclean
                JNE             tbavcheck
                JMP             tbscancheck        
                
tbavcheck:
                CMP             AH,03Fh                 ;tbav
                JNE             catch
                CMP             CX,0FFFFh
                JNE             catch
                
tbscancheck:                
                MOV             BP,SP
                MOV             AX,WORD PTR [BP+0Ch]
                MOV             DS,AX
                MOV             BX,0495h
                CMP             BYTE PTR [BX+5],0EBh
                JE              catch
                MOV             AX,006F6h
                CMP             WORD PTR [BX],AX
                JNE             tbcleancheck
                MOV             AX,00178h
                CMP             WORD PTR [BX+2],AX
                JNE             tbcleancheck
                MOV             AX,0740Fh
                CMP             WORD PTR [BX+4],AX
                JNE             tbcleancheck
                MOV             BYTE PTR [BX+5],0EBh
                MOV             BX,4739h                
                CALL            removebeg
                JMP             exittoint21                
                
tbcleancheck:
                MOV             BX,0477h
                CMP             BYTE PTR [BX+5],0EBh
                JE              catch
                CMP             BYTE PTR [BX-0F4h],0EBh
                JE              catch
                MOV             AX,006F6h
                CMP             WORD PTR [BX],AX
                JNE             tbavcheck2
                MOV             AX,000B2h
                CMP             WORD PTR [BX+2],AX
                JNE             tbavcheck2
                MOV             AX,0740Fh
                CMP             WORD PTR [BX+4],AX
                JNE             tbavcheck2
                MOV             BYTE PTR [BX+5],0EBh
                MOV             BYTE PTR [BX-0F4h],0EBh 
                MOV             BX,308Ch
                CALL            removebeg
catch:          JMP             catch2                
                
tbavcheck2:
                MOV             BX,0A62h
                MOV             AX,065E8h
                CMP             WORD PTR [BX],AX
                JNE             tbscanxcheck
                MOV             AX,0B818h       
                CMP             WORD PTR [BX+2],AX
                JNE             tbscanxcheck
                MOV             BX,1B80h
                CALL            removebeg
                JMP             exittoint21
                
tbscanxcheck:   
                MOV             BX,0BF6h
                CALL            check1
                JNE             tbmemcheck           
                CALL            check3
                JNE             tbmemcheck
                MOV             AX,00AD8h
                CALL            check2
                JNE             tbmemcheck              
                MOV             BX,0AD8h
                CMP             BYTE PTR [BX],00h
                JE              catch2
                CALL            patch
                MOV             BX,14B6h
                CALL            patch
                JMP             catch2
                
tbmemcheck:     MOV             BX,06DCh
                CALL            check1
                JNE             tbcheckcheck
                CALL            check3
                JNE             tbcheckcheck
                MOV             AX,008A2h
                CALL            check2
                JNE             tbcheckcheck
                MOV             BX,08A2h
                CMP             BYTE PTR [BX],00h
                JE              catch2
                CALL            patch
                MOV             BX,0A40h
                CALL            patch
                JMP             exittoint21
                
tbcheckcheck:   MOV             BX,0603h
                CALL            check1
                JNE             tbfilecheck
                CALL            check3
                JNE             tbfilecheck
                MOV             AX,0075Bh
                CALL            check2
                JNE             tbfilecheck
                MOV             BX,075Bh
                CMP             BYTE PTR [BX],00h
                JE              exittoint21
                CALL            patch
                MOV             BX,0993h
                CALL            patch
catch2:         JMP             exittoint21

tbfilecheck:    MOV             BX,0811h
                CALL            check1
                JNE             tbdiskcheck
                CALL            check3
                JNE             tbdiskcheck
                MOV             AX,00978h
                CALL            check2
                JNE             tbdiskcheck
                MOV             BX,0978h
                CMP             BYTE PTR [BX],00h
                JE              exittoint21
                CALL            patch
                MOV             BX,0AF5h
                CALL            patch
                JMP             exittoint21

tbdiskcheck:    MOV             BX,071Eh
                CALL            check1
                JNE             exittoint21
                CALL            check3
                JNE             exittoint21
                MOV             AX,0092Ah
                CALL            check2
                JNE             exittoint21
                MOV             BX,092Ah
                CMP             BYTE PTR [BX],00h
                JE              exittoint21
                CALL            patch
                MOV             BX,0B7Dh
                CALL            patch
                JMP             exittoint21

check1:                
                MOV             AX,006F6h
                CMP             WORD PTR [BX],AX
                RET

check2:
                CMP             WORD PTR [BX+2],AX
                RET
                
check3:
                MOV             AX,0750Fh
                CMP             WORD PTR [BX+4],AX
                RET                
                
patch:                
                MOV             BYTE PTR [BX],00h
                RET

exittoint21:
                POP             DS
                POP             BP
                POP             BX
                POP             AX
                POPF
                JMP             DWORD PTR [cs:int21orig1]

removebeg:
                XOR             AX,AX
looperase:      MOV             BYTE PTR [BX],020h
                INC             AX
                INC             BX
                CMP             AX,041h
                JNE             looperase
                RET

tsrsetup:
                MOV             AX,3521h
                INT             21h
                CMP             BX,OFFSET tsr
                JE              already
                MOV             AX,0900h
                MOV             DX,OFFSET startup
                INT             21h
                MOV             int21orig1,BX
                MOV             int21orig2,ES
                MOV             AX,2521h
                MOV             DX,OFFSET tsr
                INT             21h
                MOV             DX,OFFSET tsrsetup
                INT             27h

already:
                MOV             AX,0900h
                MOV             DX,OFFSET tsralready
                INT             21h
                MOV             AX,4C00h
                INT             21h

startup         DB              'TBAV v6.08 CRACK-REGISTRATION TSR',cr,lf 
                DB              'By The Poltergeist',cr,lf,lf
                DB              'TSR INSTALLED',cr,lf,'$'

tsralready      DB              'TSR ALREADY INSTALLED.',cr,lf,'$'

code            ENDS
                END             verybegin

